import matplotlib.pyplot as plt
from matplotlib.widgets import Slider
from random import *

from numpy.core.function_base import linspace

Gauss = 0 # on part d'un rectangle si 0, d'une gaussienne si >0 (1 suffit)
N_tot = 1000 # nombre de séries de mesures
N = 1   # nombre de mesures dans chaque série
m = []  # les "mesures tirées au sort"
y = []
x = linspace(-50, 150, 200)

def VideListe () :
    global y
    y = []
    for i in range(200) :
        y.append(0)

def GenereListe () :
    VideListe ()
    global m
    global y
    for i in range(N_tot) :
        nb = 0
        for j in range(N + 2*Gauss) :
            nb = nb + random()
        nb = 100* nb / (N + 2*Gauss)
        nb = round(nb)
        m.append (nb)
        y[nb+50] = y[nb+50] + 1/N_tot


def MAJ_N_tot (val) :
    global N
    global N_tot
    global histo
    global histo2
    N_tot = int(ValeurN_tot.val)
    N = 1
    GenereListe()
    histo2.set_ydata(y)
    N = int(ValeurN.val)
    GenereListe()
    histo.set_ydata(y)
    fig.suptitle(str(N_tot) + ' moyennes de ' + str(N) + ' nombres aléatoires entre 0 et 100', fontsize=20)

def MAJ_N (val) :
    global N
    global histo
    N = int(ValeurN.val)
    GenereListe()
    histo.set_ydata(y)
    fig.suptitle(str(N_tot) + ' moyennes de ' + str(N) + ' nombres aléatoires entre 0 et 100', fontsize=20)


GenereListe()

# Construction de l'histogramme
fig, ax = plt.subplots(figsize=(16,9))
fig.patch.set_facecolor('#E0E0E0')
ax.patch.set_facecolor('#525354')
plt.gcf().subplots_adjust(left = 0.1, bottom = 0.25, right = 0.9, top = 0.9, wspace = 0, hspace = 0.1)

histo2, = plt.plot (x , y, 's', color='red')
histo, = plt.plot (x , y, 's', color='skyblue')

plt.ylabel('nombre de tirages / nombre total')
plt.xlabel('x')
plt.grid(True)
plt.axis([-50, 150, -0.025, 0.1])
fig.suptitle(str(N_tot) + ' moyennes de ' + str(N) + ' nombres aléatoires entre 0 et 100', fontsize=20)


rectangle_N = plt.axes([0.3, 0.1, 0.5, 0.03])
ValeurN = Slider(rectangle_N, 'Nombre de valeurs aléatoires dans chaque série : ', 1,20, valinit=1, valstep=1)

rectangle_N_tot = plt.axes([0.3, 0.15, 0.5, 0.03])
ValeurN_tot = Slider(rectangle_N_tot, 'Nombre de séries : ', 1000,100000, valinit=1, valstep=1)

ValeurN.on_changed(MAJ_N)
ValeurN_tot.on_changed(MAJ_N_tot)



plt.show()
